//configurar variables de entorno
let oauth = () => {
	let currentLocation = 'https://'+window.location.hostname;
	let appId = 'NrUAVHsfjTJUE0NacgA7mVSogkfTuWTW';
	let urlQuery = '/wp-admin/admin-ajax.php';
	let redirect = '/wp-admin/admin.php?page=wc-settings&tab=shipping&section=envia_shipping';
	let failRedirect= '/wp-admin/plugins.php';
	let oauthHostname = 'https://oauth.ecartapi.com';
	let thispluginUrl = '/wp-admin/admin.php?page=wc-settings&tab=shipping&section=envia_shipping';
	let win = window.open( `${oauthHostname}/oauth/woocommerce/${appId}?url=${currentLocation}&state=fromPlugin`, '', 'width=800, height=900');
	let close = setInterval(function () {
		if(win.closed){
			ajaxCheckRequest( urlQuery, 'check', thispluginUrl, thispluginUrl );
			clearInterval(close);
		}
	},1000)
}

let ajaxCheckRequest = ( url, status, doneRedirect, failRedirect ) => {
	jQuery.ajax({
		type: 'GET',
		url:url,
		data: { 'action': 'envia_check', 'status': status },
		dataType: 'json'
	})
	.done( function(res) {
		if(res.status == 'success') {
			if( doneRedirect ){
				window.location.href = doneRedirect;
			}
		}
	})
	.fail( function( error ) {
		if( failRedirect ) {
			window.location.href = failRedirect;
		}
	})
}

jQuery(function() {
	let checkUrl = new URL ( window.location );
	if( oauthData.status == 'false' ) {
		location = '/wp-admin/admin.php?page=wc-settings&tab=shipping&section=envia_shipping'; 
		window.location.href = '/wp-admin/admin.php?page=wc-settings&tab=shipping&section=envia_shipping';
	}
	if( checkUrl.searchParams.get( 'section' ) == 'envia_shipping') { 
		let button =  document.createElement( 'input' );
		let table = document.getElementsByClassName( 'form-table' )[0];
		let div = document.createElement( 'div' );
		let p = document.createElement( 'p' );
		let imgPath = '/wp-content/plugins/'+oauthData.dirname+'/admin/images/';
		button.type = 'button';
		button.id = 'envia_oauth';
		div.id = 'div-envia-oauth';
		div.style = 'display: flex';
		p.innerHTML = oauthData.status == 'true' ? 'You store is now connected to <img class = "p-img" src="'+imgPath+'envia-logo-dark.svg" alt = "Envia.com">. Something wrong?' : 'You need connect your store to <img class = "p-img" src="'+imgPath+'envia-logo-dark.svg" alt = "Envia.com">' ;
		p.style = 'display:flex; padding-right: 8px; font-weight: 600; align-items: center;';
		button.className = 'button button-primary button-hero';
		if( oauthData.status == 'wait' ) { 
			button.style = 'box-shadow: rgb(185 187 200) 0px 0px 2px 2px inset; background: #f24901;border-color: #ff814b';
			button.value = 'Click to start with Envia.com';
			console.info("The plugin is active but without Oauth.");
		}
		if( oauthData.status == 'true' ) { 
			button.style = 'box-shadow: #b0baff 0px 0px 5px 2px inset; ';
			button.value = 'Refresh connection';
			console.info("The plugin is active.");
		}
		table.parentNode.insertBefore( div, table );
		document.getElementById( 'div-envia-oauth' ).append( p );
		document.getElementById( 'div-envia-oauth' ).append( button );
		document.getElementById( 'envia_oauth' ).addEventListener( 'click', function(){
			oauth()	
		})
	}
})

