function loadAddressInputData ( inputMain, param, output ) {
    let currentState =  jQuery("#woocommerce_envia_shipping_state").val();
    let country = document.getElementById( param ).value;
	inputMain.change( function() {
	    let currentState =  this.options[this.selectedIndex].value;
	    let country = document.getElementById( param ).value;
	    ajaxGetCities( country, currentState, output );
	})
	    ajaxGetCities( country, currentState, output )
}

function ajaxGetCities ( country, state, output ) {
	let city = document.getElementById( output );
	jQuery.ajax({
		'url' : '/wp-admin/admin-ajax.php',
		'method': 'GET',
		'data': { 'action': 'envia_cities', 'country': country, 'state': state },
		'dataType' : 'json'
	})
	.done( function ( response ) {
		let lastValue = jQuery( '#'+output ).val();
		jQuery( '#'+output ).empty();
			let newOption = document.createElement("option");
			newOption.value = 'default';
			newOption.text = 'Select a city';
			city.options.add( newOption, 0 );
		response.forEach( (element, index) => {
			let newOption = document.createElement("option");
			newOption.value = element.name;
			newOption.text = element.name;
			city.options.add( newOption, index+1 );
		})
		Array.from( city.options ).forEach( option => {
			if( option.value == lastValue )
				city.value = lastValue
		})
	})
	.fail( function( error ){
		console.log(error)
	})
}


/**
 * 
 * init values, we have to check if the dom inputs exists
 * 
 **/
jQuery(function() {
	let possibleInputs = [ 
		// {
		// 	inputCountryId : 'calc_shipping_country',
		// 	inputStateId : 'calc_shipping_state',
		// 	inputCityId: 'calc_shipping_city'
		// },
		{
			inputCountryId : 'envia-shipping-country',
			inputStateId : 'woocommerce_envia_shipping_state',
			inputCityId: 'woocommerce_envia_shipping_city'
		},
		{
			inputCountryId : 'billing_country',
			inputStateId : 'billing_state',
			inputCityId: 'billing_city'
		},
		{
			inputCountryId : 'shipping_country',
			inputStateId : 'shipping_state',
			inputCityId: 'shipping_city'
		},
	]
	possibleInputs.forEach( obj => { 
		
		if( jQuery('#'+obj.inputStateId).length > 0 ) {
			let inputMain = jQuery('#'+obj.inputStateId);
			let output = obj.inputCityId;
			let param = obj.inputCountryId;
			//param puede ser objeto ej: param = { country : obj.inputCountryId } 
			loadAddressInputData( inputMain, param, output );
		}  
		//para input de colonias sera necesario crear select inputNeihborhoodId para output y hacer de inputCityId el inputMain
		// if( jQuery('#'+obj.inputStateId).length > 0 ) {
		// 	let inputMain = jQuery('#'+obj.inputStateId);
		// 	let output = obj.inputCityId;
		// 	let param = obj.inputCountryId;
		// 	loadAddressInput( inputMain, param, output );
		// }  
	} )

	changeOriginDefault ()
})